%define desktopvendor fedora

%{!?python_sitelib: %define python_sitelib %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib()")}

Name:           bittorrent
Version:        4.0.2
Release:        0.%{mysig}
Summary:        BitTorrent swarming network file transfer tool

Group:          Applications/Internet
License:        BitTorrent Open Source License
URL:            http://www.bittorrent.com/
Source0:        http://dl.sf.net/bittorrent/BitTorrent-%{version}.tar.gz
Source1:        bittorrent.desktop
Source2:        bittorrent.png
Source3:	btseed.init
Source4:	bttrack.init
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildArch:      noarch

BuildRequires:  python-devel desktop-file-utils
Requires:       python
Requires:       python-abi = %(%{__python} -c "import sys ; print sys.version[:3]")

Requires(pre):  %{_sbindir}/useradd
Requires(post): /sbin/chkconfig
Requires(post): /sbin/service
Requires(preun): /sbin/chkconfig
Requires(preun): /sbin/service
Requires(postun): %{_sbindir}/userdel
Requires(postun): %{_sbindir}/groupdel
Requires(postun): /sbin/service

%description
BitTorrent is a tool for copying files from one machine to
another. FTP punishes sites for being popular: Since all uploading is
done from one place, a popular site needs big iron and big
bandwidth. With BitTorrent, clients automatically mirror files they
download, making the publisher's burden almost nothing.

%package        gui
Summary:        GUI versions of the BitTorrent file transfer tool
Group:          Applications/Internet
Requires:       pygtk2
Requires:       %{name} = %{version}-%{release}
Requires(post): desktop-file-utils
Requires(postun): desktop-file-utils

%description    gui
This package contains the GUI versions of the BitTorrent file transfer
tool.

%prep
%setup -q -n BitTorrent-%{version}
%{__sed} -i "s/appdir = .*/appdir = '%{name}-%{version}'/" BitTorrent/__init__.py

%{__cat} <<EOF >btseed.sysconfig
#DIR=%{_localstatedir}/spool/bittorrent
OPTIONS="--max_upload_rate 350"
EOF

%{__cat} <<EOF >bttrack.sysconfig
#PORT=6969
#DIR=%{_localstatedir}/spool/bittorrent
#STATEFILE=%{_localstatedir}/lib/bittorrent/bttrack
#LOGFILE=%{_localstatedir}/log/bittorrent/bttrack.log
OPTIONS="--show_names 1 --hupmonitor 1"
EOF

%{__cat} <<EOF >torrent.logrotate
%{_localstatedir}/log/bittorrent/bttrack.log {
	notifempty
	missingok
	postrotate
		/sbin/service bttrack condrestart 2>/dev/null >/dev/null || true
	endscript
}
EOF

%build
CFLAGS="$RPM_OPT_FLAGS" %{__python} setup.py build

%install
%{__rm} -rf $RPM_BUILD_ROOT
%{__python} setup.py install -O1 --skip-build --root $RPM_BUILD_ROOT
%{__sed} -i -e 's/env python2/env python/' $RPM_BUILD_ROOT%{_bindir}/*

%{_bindir}/desktop-file-install --vendor %{desktopvendor} \
	--dir $RPM_BUILD_ROOT%{_datadir}/applications \
	--add-category X-Fedora \
	%{SOURCE1}
%{__install} -d $RPM_BUILD_ROOT%{_localstatedir}/{spool,lib,log}/bittorrent
%{__install} -m 0644 -D %{SOURCE2}        $RPM_BUILD_ROOT%{_datadir}/pixmaps/bittorrent.png
%{__install} -m 0755 -D %{SOURCE3}        $RPM_BUILD_ROOT%{_sysconfdir}/rc.d/init.d/btseed
%{__install} -m 0755 -D %{SOURCE4}        $RPM_BUILD_ROOT%{_sysconfdir}/rc.d/init.d/bttrack
%{__install} -m 0644 -D btseed.sysconfig  $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/btseed
%{__install} -m 0644 -D bttrack.sysconfig $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/bttrack
%{__install} -m 0644 -D torrent.logrotate $RPM_BUILD_ROOT%{_sysconfdir}/logrotate.d/bittorrent

%clean
%{__rm} -rf $RPM_BUILD_ROOT

%pre
%{_sbindir}/useradd -r -s /sbin/nologin -d %{_localstatedir}/spool/bittorrent \
	-c "BitTorrent Seed/Tracker" torrent &>/dev/null || :

%post
/sbin/chkconfig --add btseed  || :
/sbin/chkconfig --add bttrack || :

%preun
if [ $1 -eq 0 ]; then
	/sbin/service btseed  stop &>/dev/null || :
	/sbin/service bttrack stop &>/dev/null || :
	/sbin/chkconfig --del btseed  || :
	/sbin/chkconfig --del bttrack || :
fi

%postun
if [ $1 -eq 0 ]; then
	%{_sbindir}/userdel  torrent &>/dev/null || :
	%{_sbindir}/groupdel torrent &>/dev/null || :
else
	/sbin/service btseed  condrestart &>/dev/null || :
	/sbin/service bttrack condrestart &>/dev/null || :
fi

%post gui
%{_bindir}/update-desktop-database %{_datadir}/applications &>/dev/null || :

%postun gui
%{_bindir}/update-desktop-database %{_datadir}/applications &>/dev/null || :

%files
%defattr(-,root,root,-)
%doc README.txt credits.txt LICENSE.txt
%{_bindir}/btdownloadcurses.py
%{_bindir}/btdownloadheadless.py
%{_bindir}/btlaunchmany.py
%{_bindir}/btlaunchmanycurses.py
%{_bindir}/btmaketorrent.py
%{_bindir}/btreannounce.py
%{_bindir}/btrename.py
%{_bindir}/btshowmetainfo.py
%{_bindir}/bttrack.py
%dir %{python_sitelib}/BitTorrent
%{python_sitelib}/BitTorrent/*.py
%{python_sitelib}/BitTorrent/*.pyc
%ghost %{python_sitelib}/BitTorrent/*.pyo
%attr(-,torrent,torrent) %dir %{_localstatedir}/spool/bittorrent
%attr(-,torrent,torrent) %dir %{_localstatedir}/lib/bittorrent
%attr(-,torrent,torrent) %dir %{_localstatedir}/log/bittorrent
%{_sysconfdir}/rc.d/init.d/btseed
%{_sysconfdir}/rc.d/init.d/bttrack
%config(noreplace) %{_sysconfdir}/logrotate.d/bittorrent
%config(noreplace) %{_sysconfdir}/sysconfig/btseed
%config(noreplace) %{_sysconfdir}/sysconfig/bttrack

%files gui
%defattr(-,root,root,-)
%{_bindir}/btdownloadgui.py
%{_bindir}/btmaketorrentgui.py
%{_datadir}/applications/%{desktopvendor}-bittorrent.desktop
%{_datadir}/pixmaps/%{name}-%{version}
%{_datadir}/pixmaps/bittorrent.png

%changelog
* Wed Sep 21 2005 Milan Kerslager <kerslage@linux.cz> 4.0.2-0.ker.rhel3
- rebuild for RHEL4 (package from FC4 Extras)

* Tue May 24 2005 Paul Howarth <paul@city-fan.org> 4.0.2-1%{?dist}
- Update to 4.0.2

* Mon May 23 2005 Paul Howarth <paul@city-fan.org> 4.0.1-2%{?dist}
- use macros consistently throughout
- add initscripts so users can easily set up trackers and seeders
  on their own (#158273)
- add user torrent for tracker/seeder
- add logrotate script for tracker

* Wed May 18 2005 Paul Howarth <paul@city-fan.org> 4.0.1-1%{?dist}
- new upstream release 4.0.1 (#157632)
- add dist tag
- source now found on sourceforge.net
- move post/postun scriptlets to -gui subpackage
- bttest.py removed upstream

* Tue Mar 15 2005 Michael Schwendt <mschwendt[AT]users.sf.net> - 4.0.0-2
- add desktop file, desktop menu icon, post/postun scriptlets

* Mon Mar 14 2005 David Hill <djh[at]ii.net> - 4.0.0-1
- update to 4.0.0, no longer requires wxPythonGTK

* Wed Dec 22 2004 Michael Schwendt <mschwendt[AT]users.sf.net> - 0:3.4.1-3.a
- x86_64: Fix python dependency, replace with python-abi dependency.

* Mon Mar 29 2004 Marius L. Jøhndal <mariuslj at ifi.uio.no> - 0:3.4.1-0.fdr.2.a
- Changed Requires wxPythonGTK to wxPython (bug 1416).
- Converted spec file to UTF-8.

* Thu Mar 25 2004 Marius L. Jøhndal <mariuslj at ifi.uio.no> - 0:3.4.1-0.fdr.1.a
- Updated to 3.4.1a.
- Brought in line with the Python spec template.
- Fixed group and missing epoch in requires for gui subpackage.
- Eliminated multiple copies of README.txt.
- Eliminated perl BuildReq.

* Wed Jul 16 2003 Seth Vidal <skvidal@phy.duke.edu>
- rebuild under 7.3
- some fixes

* Wed Jul 16 2003 Warren Togami <warren@togami.com> 3.2.1-0.fdr.2.b
- Fedoraize

* Wed Jul 16 2003 Seth Vidal <skvidal@phy.duke.edu>
- rebuilt on rhl 9 - testing

* Fri May 30 2003 Peter Hanecak <hanecak@megaloman.sk> 3.2.1b-1
- adapted to Doors Linux

* Sun Mar 30 2003 Götz Waschk <waschk@linux-mandrake.com> 3.2.1b-1mdk
- split out gui tools to remove wxPythonGTK dep from the main package
- new version

* Fri Mar 28 2003 Frederic Lepied <flepied@mandrakesoft.com> 3.2-1mdk
- 3.2

* Wed Mar 26 2003 Frederic Lepied <flepied@mandrakesoft.com> 3.1-1mdk
- initial packaging
